indexing

	description:

		"Cells containing two items"

	library:    "Gobo Eiffel Structure Library"
	author:     "Eric Bezault <ericb@gobo.demon.co.uk>"
	copyright:  "Copyright (c) 1997, Eric Bezault"
	date:       "$Date: 1997/07/28 18:14:30 $"
	revision:   "$Revision: 1.2 $"

class DS_PAIR [G, H]

inherit

	DS_CELL [G]
		rename
			item as first,
			put as put_first,
			make as make_first
		export
			{NONE} make_first
		end

creation

	make

feature {NONE} -- Initialization

	make (v: G; w: H) is
			-- Create a new cell containing `v' and `w'.
		do
			first := v
			second := w
		ensure
			first_set: first = v
			second_set: second = w
		end

feature -- Access

	second: H
			-- Second item of cell

feature -- Element change

	put_second (w: like second) is
			-- Insert `w' in cell.
		do
			second := w
		ensure
			inserted: second = w
		end

end -- class DS_PAIR
